
<template>
  <button class="red" @click="logOut" :disabled="disabled">Log Out</button>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
import { logout } from "@/services/backends/users";
import { MessageType, commit } from "@/store/messages";
import store from "@/store/";

@Component
export default class LogOutBtn extends Vue {
  private disabled = false;

  async logOut(): Promise<void> {
    this.disabled = true;
    try {
      await logout();
      store.commit(commit.display, {
        type: MessageType.White,
        title: "You have been logged out"
      });
      this.$router.push("/");
    } finally {
      this.disabled = false;
    }
  }
}
</script>

<style scoped>
</style>
